package org.colinvella.fancyfish.gui;

import java.util.Random;

import org.colinvella.fancyfish.FancyFishMod;
import org.colinvella.fancyfish.inventory.TeleportContainer;
import org.colinvella.fancyfish.item.FishScaleItem;
import org.colinvella.fancyfish.item.FishScaleItem.Colour;
import org.colinvella.fancyfish.tileentity.TeleportTileEntity;
import org.lwjgl.opengl.GL11;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class TeleportGuiContainer extends ModGuiContainer
{
	public TeleportGuiContainer(IInventory playerInventory, TeleportTileEntity teleportTileEntity)
	{
		super(new TeleportContainer(playerInventory, teleportTileEntity));
		this.playerInventory = playerInventory;
		this.teleportTileEntity = teleportTileEntity;
		this.inventoryRows = 1;
		this.xSize = 176;
		this.ySize = 172;
	}

	@Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        this.fontRendererObj.drawString(this.teleportTileEntity.getDisplayName().getUnformattedText(), 8, 6, 0x404040);
        this.fontRendererObj.drawString(this.playerInventory.getDisplayName().getUnformattedText(), 8, this.ySize - 96 + 3, 0x404040);
    }
    
	@Override public void initGui()
	{
		super.initGui();
		guiLeft = (this.width - this.xSize) / 2;
		guiTop = (this.height - this.ySize) / 2;
	};
	
	@Override
	protected void drawGuiContainerBackgroundLayer(float partialTicks, int mouseX, int mouseY)
	{
        GlStateManager.pushAttrib();

        this.mc.getTextureManager().bindTexture(TELEPORT_GUI_BACKGROUND);
        this.drawTexturedModalRect(guiLeft, guiTop, 0, 0, this.xSize, this.ySize);

		ItemStack itemStack = this.inventorySlots.getSlot(0).getStack();
		if (itemStack == null)
		{
	        GlStateManager.popAttrib();
			return;
		}
		
		FishScaleItem fishScaleItem = (FishScaleItem) itemStack.getItem();
		Colour colour = fishScaleItem.getColour();

		GlStateManager.enableBlend();
		GlStateManager.enableAlpha();
		GlStateManager.blendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);

		GlStateManager.color(colour.red, colour.green, colour.blue, this.teleportTileEntity.getCharge());
        this.drawTexturedModalRect(this.width / 2 - 40 , this.guiTop, 176, 0, 80, 100);
        
        GlStateManager.popAttrib();
	}
	
	@Override
	public void updateScreen()
	{
        super.updateScreen();
	};
	
	private IInventory playerInventory;
	private TeleportTileEntity teleportTileEntity;
	private int inventoryRows;
	private int guiLeft = 0;
	private int guiTop = 0;
	
    private static final ResourceLocation TELEPORT_GUI_BACKGROUND
    	= new ResourceLocation(FancyFishMod.MOD_ID + ":textures/gui/Teleport.png");
}
