package org.colinvella.fancyfish.logger;

import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.core.Logger;
import org.colinvella.fancyfish.FancyFishMod;

import net.minecraftforge.fml.common.TracingPrintStream;

public class ModLogger
{
	public ModLogger(Level threshold)
	{
		this.threshold = threshold;
		System.setOut(printStream);
	}
	
	public void fatal(Object message)
	{
		log(Level.FATAL, message);
	}

	public void error(Object message)
	{
		log(Level.ERROR, message);
	}

	public void warn(Object message)
	{
		log(Level.WARN, message);
	}

	public void info(Object message)
	{
		log(Level.INFO, message);
	}
	
	public void debug(Object message)
	{
		log(Level.DEBUG, message);
	}

	public void trace(Object message)
	{
		log(Level.TRACE, message);
	}
	
	public void log(Level level, Object message)
	{
		if (!level.isAtLeastAsSpecificAs(threshold))
			return;
		System.out.println("(" + level + ") " + message);
	}			
	
	private Level threshold = Level.ALL;
	
	private static ModPrintStream printStream = new ModPrintStream(LogManager.getLogger("FML"), System.out);
}
